<template>
  <b-overlay
    id="overlay-background"
    no-wrap
    :fixed="true"
    :show="isWaitingForResponse"
    :variant="'white'"
    :opacity="0.65"
    :z-index="2000"
    :blur="''"
    rounded="sm"
  >
    <template #overlay>
      <div class="text-center">
        <h5>{{ textBefore }}</h5>
        <b-spinner
          label="Loading ..."
          class="b-spinner-opts"
          :style="{ color: color }"
        >
        </b-spinner>
        <h5>{{ textAfter }}</h5>
      </div>
    </template>
  </b-overlay>
</template>

<script lang="ts">
import { BOverlay, BSpinner } from "bootstrap-vue";

export default {
  name: "LoadingSpinner",
  components: {
    BOverlay,
    BSpinner,
  },
  props: {
    color: {
      default: "#00549f",
      type: String,
    },
    isWaitingForResponse: {
      default: false,
      type: Boolean,
    },
    textBefore: {
      default: "",
      type: String,
    },
    textAfter: {
      default: "",
      type: String,
    },
  },
};
</script>

<style>
.b-spinner-opts {
  height: 8rem;
  width: 8rem;
}
</style>
